# Code for "Provable Posterior Sampling with Denoising Oracles through Tilted Transport" on Gaussian mixture models

## Install

```
conda env create -f environment.yml
```

## Quick test

```
python main_gmm_analytic.py
```

## Running experiments in Figure 1

```
python main_gmm_langevin.py example.dim=20 example.dim_y=20 example.kappa_range='[20, 20]' example.snr_range='[1e-5, 1e-5]'
```
Both samples for Langevin and Booster Langevin will be computed and saved. random_key can be additionally passed as an argument

## Running experiments in Table 1 (Appendix D)

```
python main_gmm_langevin.py example.dim=20 example.dim_y=18
```
or
```
python main_gmm_nuts.py example.dim=20 example.dim_y=1
```